execbaseinit set 0
printfused	set 0

_LVOOutput     		EQU   -60
_LVOOpenLibrary     EQU   -552
_LVOCloseLibrary    EQU   -414

; mOpenLibrary "foo.library",version,variableBase
mOpenLibrary	macro
	movem.l d1/a0/a1/a6,-(sp)
	ifge execbaseinit
	move.l $4.w,a6
	move.l a6,_SysBase
	bra.s s1\@
_SysBase	dc.l 0
s1\@
execbaseinit set 1
	endc

	lea.l	n1\@,a1
	moveq.l #\2,d0
	move.l  _SysBase,a6
	jsr 	_LVOOpenLibrary(a6)
	bra.s   n2\@
n1\@ dc.b 	\1,0
	cnop 	0,2
	XDEF	\3
	XDEF	_\3
_\3
\3 	dc.l 	0
	cnop	0,2
n2\@
	movem.l (sp)+,d1/a0/a1/a6
	move.l 	d0,\3
	endm


; mCloseLibrary LibraryBase
mCloseLibrary macro
	movem.l d0/d1/a0/a1/a6,-(sp)
	move.l 	\1,a1
	move.l  _SysBase,a6
	jsr   	_LVOCloseLibrary(a6)
	movem.l (sp)+,d0/d1/a0/a1/a6
endm


mprintf 	macro
	
	; save all regs
	movem.l	d0/d1/a0/a1,-(a7)

	ifge printfused
	movem.l d0/d1/a0/a1/a6,-(sp)
	move.l DOSBase,a6
	jsr		_LVOOutput(a6)
	move.l 	d0,_stdout
	bra.s  s1\@
	XDEF _stdout
_stdout dc.l 0
s1\@
	movem.l (sp)+,d0/d1/a0/a1/a6
printfused set -1
	endc

	IFGE	NARG-9
		move.l	\9,-(sp)		; stack arg8
	ENDC
	IFGE	NARG-8
		move.l	\8,-(sp)		; stack arg7
	ENDC
	IFGE	NARG-7
		move.l	\7,-(sp)		; stack arg6
	ENDC
	IFGE	NARG-6
		move.l	\6,-(sp)		; stack arg5
	ENDC
	IFGE	NARG-5
		move.l	\5,-(sp)		; stack arg4
	ENDC
	IFGE	NARG-4
		move.l	\4,-(sp)		; stack arg3
	ENDC
	IFGE	NARG-3
		move.l	\3,-(sp)		; stack arg2
	ENDC
	IFGE	NARG-2
		move.l	\2,-(sp)		; stack arg1
	ENDC

PULLSP	SET	(NARG)<<2		
	pea.l	n1\@
	jsr	_printf
	lea.l	PULLSP(sp),sp			
	movem.l	(a7)+,d0/d1/a0/a1
	bra.s	n2\@

n1\@	dc.b	\1,0
	cnop	0,2
n2\@
	endm